
var Iterator = require("./iterator").Iterator;

Iterator.range(10).forEach(function (n) {
    console.log(n);
});

Iterator.iterate([1,2,3]).forEach(function (n) {
    console.log(n);
});

console.log('cycle');
var c = Iterator.cycle([0, 1]);
console.log(c.next());
console.log(c.next());
console.log(c.next());

console.log('cycle string');
Iterator.cycle("ab", 1).forEach(function (n) {
    console.log(n);
});

console.log('repeat 1 ten times');
Iterator.repeat(1, 10).forEach(console.log);

console.log('reduce');
var sum = Iterator.range(10).reduce(function (xs, x, i) {
    console.log(xs, x, i);
    return xs + x;
}, 0);
console.log(sum);

console.log('every');
var g = Iterator.range(10);
console.log(g.every(function (n) {
    return n < 5;
}));
console.log(g.toArray());

console.log('generic on array');
Iterator.prototype.forEach.call([1,2,3], console.log);

console.log('count some');
console.log(Iterator.count().some(function (n) {
    return n > 100;
}));

console.log('count every');
console.log(Iterator.count().every(function (n) {
    return n < 100;
}));

console.log('count all');
console.log(Iterator.count().all());
console.log('count any');
console.log(Iterator.count().any());

console.log('concat');
Iterator.concat([Iterator.range(3), Iterator.range(3)])
.forEach(console.log);

Iterator.range(3).concat(Iterator.range(3))
.forEach(console.log);

console.log('chain');
Iterator.chain(Iterator.range(3), Iterator.range(3))
.forEach(console.log);

console.log("drop while");
Iterator.range(20).dropWhile(function (n) {
    return n < 10;
}).forEach(console.log);

console.log("take while");
Iterator.range(20).takeWhile(function (n) {
    return n < 10;
}).forEach(console.log);

// transpose
console.log("transpose");
Iterator.transpose([
    Iterator.count(),
    Iterator("abc")
]).forEach(console.log);

// zip
console.log("zip");
Iterator.zip(
    Iterator.count(),
    Iterator("abc")
).forEach(console.log);

// .zip
console.log(".zip");
Iterator.count().zip("abc")
.forEach(console.log);

// filter
console.log(".filter")
Iterator.range(10).filter(function (n) {
    return n & 1;
})
.forEach(console.log);

// enumerate
console.log('enumerate');
console.log(Iterator("abc").enumerate().toArray());
console.log(Iterator("abc").enumerate(1).toArray());
console.log(Iterator("abc").enumerate(1, 'i', 'x').toArray());

